package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.VehicleAttribute;
import de.humance.eco.profile.model.VehicleAttributeModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the VehicleAttribute service. Represents a row in the &quot;Profile_VehicleAttribute&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.VehicleAttributeModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link VehicleAttributeImpl}.
 * </p>
 *
 * @author Humance
 * @see VehicleAttributeImpl
 * @see de.humance.eco.profile.model.VehicleAttribute
 * @see de.humance.eco.profile.model.VehicleAttributeModel
 * @generated
 */
public class VehicleAttributeModelImpl extends BaseModelImpl<VehicleAttribute>
    implements VehicleAttributeModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a vehicle attribute model instance should use the {@link de.humance.eco.profile.model.VehicleAttribute} interface instead.
     */
    public static final String TABLE_NAME = "Profile_VehicleAttribute";
    public static final Object[][] TABLE_COLUMNS = {
            { "vehicleAttributeId", Types.BIGINT },
            { "vehicleId", Types.BIGINT },
            { "vehicleAttributeDefinitionId", Types.BIGINT },
            { "type_", Types.VARCHAR },
            { "sequenceNumber", Types.BIGINT },
            { "attributeValue", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_VehicleAttribute (vehicleAttributeId LONG not null primary key,vehicleId LONG,vehicleAttributeDefinitionId LONG,type_ VARCHAR(75) null,sequenceNumber LONG,attributeValue TEXT null)";
    public static final String TABLE_SQL_DROP = "drop table Profile_VehicleAttribute";
    public static final String ORDER_BY_JPQL = " ORDER BY vehicleAttribute.vehicleId ASC, vehicleAttribute.sequenceNumber ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_VehicleAttribute.vehicleId ASC, Profile_VehicleAttribute.sequenceNumber ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.VehicleAttribute"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.VehicleAttribute"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.VehicleAttribute"),
            true);
    public static long VEHICLEATTRIBUTEDEFINITIONID_COLUMN_BITMASK = 1L;
    public static long VEHICLEID_COLUMN_BITMASK = 2L;
    public static long SEQUENCENUMBER_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.VehicleAttribute"));
    private static ClassLoader _classLoader = VehicleAttribute.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            VehicleAttribute.class
        };
    private long _vehicleAttributeId;
    private long _vehicleId;
    private long _originalVehicleId;
    private boolean _setOriginalVehicleId;
    private long _vehicleAttributeDefinitionId;
    private long _originalVehicleAttributeDefinitionId;
    private boolean _setOriginalVehicleAttributeDefinitionId;
    private String _type;
    private long _sequenceNumber;
    private String _attributeValue;
    private long _columnBitmask;
    private VehicleAttribute _escapedModel;

    public VehicleAttributeModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _vehicleAttributeId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setVehicleAttributeId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _vehicleAttributeId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return VehicleAttribute.class;
    }

    @Override
    public String getModelClassName() {
        return VehicleAttribute.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("vehicleAttributeId", getVehicleAttributeId());
        attributes.put("vehicleId", getVehicleId());
        attributes.put("vehicleAttributeDefinitionId",
            getVehicleAttributeDefinitionId());
        attributes.put("type", getType());
        attributes.put("sequenceNumber", getSequenceNumber());
        attributes.put("attributeValue", getAttributeValue());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long vehicleAttributeId = (Long) attributes.get("vehicleAttributeId");

        if (vehicleAttributeId != null) {
            setVehicleAttributeId(vehicleAttributeId);
        }

        Long vehicleId = (Long) attributes.get("vehicleId");

        if (vehicleId != null) {
            setVehicleId(vehicleId);
        }

        Long vehicleAttributeDefinitionId = (Long) attributes.get(
                "vehicleAttributeDefinitionId");

        if (vehicleAttributeDefinitionId != null) {
            setVehicleAttributeDefinitionId(vehicleAttributeDefinitionId);
        }

        String type = (String) attributes.get("type");

        if (type != null) {
            setType(type);
        }

        Long sequenceNumber = (Long) attributes.get("sequenceNumber");

        if (sequenceNumber != null) {
            setSequenceNumber(sequenceNumber);
        }

        String attributeValue = (String) attributes.get("attributeValue");

        if (attributeValue != null) {
            setAttributeValue(attributeValue);
        }
    }

    @Override
    public long getVehicleAttributeId() {
        return _vehicleAttributeId;
    }

    @Override
    public void setVehicleAttributeId(long vehicleAttributeId) {
        _vehicleAttributeId = vehicleAttributeId;
    }

    @Override
    public long getVehicleId() {
        return _vehicleId;
    }

    @Override
    public void setVehicleId(long vehicleId) {
        _columnBitmask = -1L;

        if (!_setOriginalVehicleId) {
            _setOriginalVehicleId = true;

            _originalVehicleId = _vehicleId;
        }

        _vehicleId = vehicleId;
    }

    public long getOriginalVehicleId() {
        return _originalVehicleId;
    }

    @Override
    public long getVehicleAttributeDefinitionId() {
        return _vehicleAttributeDefinitionId;
    }

    @Override
    public void setVehicleAttributeDefinitionId(
        long vehicleAttributeDefinitionId) {
        _columnBitmask |= VEHICLEATTRIBUTEDEFINITIONID_COLUMN_BITMASK;

        if (!_setOriginalVehicleAttributeDefinitionId) {
            _setOriginalVehicleAttributeDefinitionId = true;

            _originalVehicleAttributeDefinitionId = _vehicleAttributeDefinitionId;
        }

        _vehicleAttributeDefinitionId = vehicleAttributeDefinitionId;
    }

    public long getOriginalVehicleAttributeDefinitionId() {
        return _originalVehicleAttributeDefinitionId;
    }

    @Override
    public String getType() {
        if (_type == null) {
            return StringPool.BLANK;
        } else {
            return _type;
        }
    }

    @Override
    public void setType(String type) {
        _type = type;
    }

    @Override
    public long getSequenceNumber() {
        return _sequenceNumber;
    }

    @Override
    public void setSequenceNumber(long sequenceNumber) {
        _columnBitmask = -1L;

        _sequenceNumber = sequenceNumber;
    }

    @Override
    public String getAttributeValue() {
        if (_attributeValue == null) {
            return StringPool.BLANK;
        } else {
            return _attributeValue;
        }
    }

    @Override
    public void setAttributeValue(String attributeValue) {
        _attributeValue = attributeValue;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            VehicleAttribute.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public VehicleAttribute toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (VehicleAttribute) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        VehicleAttributeImpl vehicleAttributeImpl = new VehicleAttributeImpl();

        vehicleAttributeImpl.setVehicleAttributeId(getVehicleAttributeId());
        vehicleAttributeImpl.setVehicleId(getVehicleId());
        vehicleAttributeImpl.setVehicleAttributeDefinitionId(getVehicleAttributeDefinitionId());
        vehicleAttributeImpl.setType(getType());
        vehicleAttributeImpl.setSequenceNumber(getSequenceNumber());
        vehicleAttributeImpl.setAttributeValue(getAttributeValue());

        vehicleAttributeImpl.resetOriginalValues();

        return vehicleAttributeImpl;
    }

    @Override
    public int compareTo(VehicleAttribute vehicleAttribute) {
        int value = 0;

        if (getVehicleId() < vehicleAttribute.getVehicleId()) {
            value = -1;
        } else if (getVehicleId() > vehicleAttribute.getVehicleId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        if (getSequenceNumber() < vehicleAttribute.getSequenceNumber()) {
            value = -1;
        } else if (getSequenceNumber() > vehicleAttribute.getSequenceNumber()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof VehicleAttribute)) {
            return false;
        }

        VehicleAttribute vehicleAttribute = (VehicleAttribute) obj;

        long primaryKey = vehicleAttribute.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        VehicleAttributeModelImpl vehicleAttributeModelImpl = this;

        vehicleAttributeModelImpl._originalVehicleId = vehicleAttributeModelImpl._vehicleId;

        vehicleAttributeModelImpl._setOriginalVehicleId = false;

        vehicleAttributeModelImpl._originalVehicleAttributeDefinitionId = vehicleAttributeModelImpl._vehicleAttributeDefinitionId;

        vehicleAttributeModelImpl._setOriginalVehicleAttributeDefinitionId = false;

        vehicleAttributeModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<VehicleAttribute> toCacheModel() {
        VehicleAttributeCacheModel vehicleAttributeCacheModel = new VehicleAttributeCacheModel();

        vehicleAttributeCacheModel.vehicleAttributeId = getVehicleAttributeId();

        vehicleAttributeCacheModel.vehicleId = getVehicleId();

        vehicleAttributeCacheModel.vehicleAttributeDefinitionId = getVehicleAttributeDefinitionId();

        vehicleAttributeCacheModel.type = getType();

        String type = vehicleAttributeCacheModel.type;

        if ((type != null) && (type.length() == 0)) {
            vehicleAttributeCacheModel.type = null;
        }

        vehicleAttributeCacheModel.sequenceNumber = getSequenceNumber();

        vehicleAttributeCacheModel.attributeValue = getAttributeValue();

        String attributeValue = vehicleAttributeCacheModel.attributeValue;

        if ((attributeValue != null) && (attributeValue.length() == 0)) {
            vehicleAttributeCacheModel.attributeValue = null;
        }

        return vehicleAttributeCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(13);

        sb.append("{vehicleAttributeId=");
        sb.append(getVehicleAttributeId());
        sb.append(", vehicleId=");
        sb.append(getVehicleId());
        sb.append(", vehicleAttributeDefinitionId=");
        sb.append(getVehicleAttributeDefinitionId());
        sb.append(", type=");
        sb.append(getType());
        sb.append(", sequenceNumber=");
        sb.append(getSequenceNumber());
        sb.append(", attributeValue=");
        sb.append(getAttributeValue());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(22);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.VehicleAttribute");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>vehicleAttributeId</column-name><column-value><![CDATA[");
        sb.append(getVehicleAttributeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>vehicleId</column-name><column-value><![CDATA[");
        sb.append(getVehicleId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>vehicleAttributeDefinitionId</column-name><column-value><![CDATA[");
        sb.append(getVehicleAttributeDefinitionId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>type</column-name><column-value><![CDATA[");
        sb.append(getType());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>sequenceNumber</column-name><column-value><![CDATA[");
        sb.append(getSequenceNumber());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>attributeValue</column-name><column-value><![CDATA[");
        sb.append(getAttributeValue());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
